import { defineComponent, computed, createVNode } from "vue";
import { Markdown as Markdown$1 } from "./markdown.mjs";
const Markdownprops = {
  source: {
    type: String,
    required: true
  },
  allowElement: {
    type: Function,
    required: false
  },
  components: {
    type: Object,
    required: false
  },
  disallowedElements: {
    type: Array,
    required: false
  },
  rehypePlugins: {
    type: Array,
    required: false
  },
  remarkPlugins: {
    type: Array,
    required: false
  },
  /**需要具体化选项的类型*/
  remarkRehypeOptions: {
    type: Object,
    required: false
  },
  skipHtml: {
    type: Boolean,
    required: false
  },
  unwrapDisallowed: {
    type: Boolean,
    required: false
  },
  urlTransform: {
    type: Function,
    required: false
  }
};
const Markdown = /* @__PURE__ */ defineComponent({
  name: "Markdown",
  props: Markdownprops,
  setup(props, {
    slots,
    attrs
  }) {
    const components = computed(() => {
      const {
        default: defaultSlot,
        ...otherSlots
      } = slots;
      const props_components = props.components || {};
      return {
        ...props_components,
        ...otherSlots
      };
    });
    const children = computed(() => {
      var _a;
      const {
        default: defaultSlot
      } = slots;
      const children2 = defaultSlot && ((_a = defaultSlot == null ? void 0 : defaultSlot()[0]) == null ? void 0 : _a.children);
      return props.source || children2;
    });
    return () => createVNode(Markdown$1, {
      "className": attrs.class,
      "components": components.value,
      "children": children.value
    }, null);
  }
});
export {
  Markdown,
  Markdown$1 as MarkdownRender,
  Markdownprops
};
